/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;


import java.util.ArrayList;

import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource.mxIEventListener;
import com.mxgraph.view.mxGraph;

import com.mxgraph.layout.*;
import com.mxgraph.model.*;
import java.util.HashMap;
import java.util.Random;
import jview.*;

/**
 *
 * @author Lou
 */
public class ClassDiagramGraph extends mxGraph
{
    private mxGraphComponent graphComponent;
     
    ClassDiagramGraph()
    {
         graphComponent = new mxGraphComponent(this);
         graphComponent.setConnectable(false);
         
         this.setHtmlLabels( true);
         
       Object parent = this.getDefaultParent();

        ArrayList<Object> objects = new ArrayList<Object>();
        HashMap<String, Object> obj = new HashMap<String, Object>();

       this.setAutoSizeCells(true);
       this.setLabelsClipped( true);
       
        this.getModel().beginUpdate();
        try {
            for (JavaEntity entity : Project.getInstance().getClasses())
            {
                if(!entity.hasEfferentCouplings() && !entity.hasAfferentCouplings())
                    continue;
                
                String html = "";
                html += "<b>" + entity.getName() + "</b><br>";
                html += "(" + entity.getPackageName() + ")";
                html += "<hr noshade size='2'>";
                html += "<div align='left'>";
                for (JavaProperty p: entity.getProperties())
                {
                    if (p.getAccess().equals("private"))
                        html += "-";
                    else if(p.getAccess().equals("protected"))
                        html += "#";
                    else
                        html += "+";

                    html += p.getName() + " : " + p.getType();;
                    if (p.getIsArray())
                        html += "[]";
                    
                    html += "<br>";
                }
                html += "</div>";
                html += "<hr noshade size='1'>";
                html += "<div align='left'>";
                for (JavaMethod m: entity.getMethods())
                {
                    html += " " + m.getName() + "() : " + m.getReturnType();
                    if (m.getReturnTypeIsArray())
                        html += "[]";
                    
                    html += "<br>";
                }
                html += "</div>";
                html += "<hr noshade size='1'>";
               
                Object v = this.insertVertex(parent, null, "<html><div style='padding:4px;color:#151515'>" + html + "</div></html>", 300, 200, 120, 40, "strokeColor=#151515;fillColor=#FFFFFF");
                this.updateCellSize(v);
                objects.add(v);
                obj.put(entity.getName(), v);
                
            }
            
            int count = 0;
            for (JavaEntity entity : Project.getInstance().getClasses())
            {
                System.out.println(entity.getName() + "***********");
                if (!obj.containsKey(entity.getName()))
                {
                    System.out.println(entity.getName());
                    continue;
                }

                String color = Integer.toHexString(new Random().nextInt(200)) +  "" + Integer.toHexString(new Random().nextInt(200)) +  "" + Integer.toHexString(new Random().nextInt(200));
                for (Relation relation: entity.getRelationsTo())
                {
                    int target = 0;
                    
                    for (JavaEntity entity2 : Project.getInstance().getClasses())
                    {
                        
                        
                        if (relation.getRelatedEntity().equals(entity2.getFullName()))
                        {
                           // this.insertEdge(parent, null,  "", objects.get(count), objects.get(target), "startArrow=none;endArrow=none;strokeWidth=4;strokeColor=#66FF00");
                             //this.insertEdge(parent, null,  "", objects.get(count), objects.get(target), "edgeStyle=orthogonalEdgeStyle;strokeColor=#" + color);
                            this.insertEdge(parent, null,  "", obj.get(entity.getName()), obj.get(entity2.getName()), "strokeColor=#" + color);
                            break;
                        }
                        target++;
                        
                    }
                }
                
                count++;
            }

            for (Object v : objects)
            {
                if (this.getModel().getEdgeCount(v) == 0)
                    this.getModel().remove(v);
            }
        }
        finally
        {
            this.getModel().endUpdate();
        }

        // define layout
        mxFastOrganicLayout layout = new com.mxgraph.layout.mxFastOrganicLayout(this);
        layout.setForceConstant( 500); // the higher, the more separated
        layout.setDisableEdgeStyle( false);
    
        // layout using morphing
        this.getModel().beginUpdate();
        
        try
        {
            layout.execute(this.getDefaultParent());
            new mxParallelEdgeLayout(this).execute(this.getDefaultParent());
        }
        finally
        {
            mxMorphing morph = new mxMorphing(graphComponent, 20, 1.2, 20);

            morph.addListener(mxEvent.DONE, new mxIEventListener()
            {
                @Override
                public void invoke(Object arg0, mxEventObject arg1)
                {
                    getModel().endUpdate();
                }

            });

            morph.startAnimation();
        }
    }

    @Override
    public boolean isCellSelectable(Object cell)
    {
         if (cell != null)
         {
            if (cell instanceof mxCell)
            {
               mxCell myCell = (mxCell) cell;
               if (myCell.isEdge())
                  return false;
            }
         }
         return super.isCellSelectable(cell);
    }
    
    public mxGraphComponent getGraphComponent()
    {
        return graphComponent;
    }
}
