/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import gui.Tag;
import java.awt.Color;
import java.util.ArrayList;
import javax.swing.*;
import java.awt.FlowLayout;
import java.awt.Font;

/**
 *
 * @author Lou
 */
public class Cloud
{
    final int MIN_FONT_SIZE = 15;
    final int MAX_FONT_SIZE = 100;
    
    private int min = 0;
    private int max = 0;
    private ArrayList<Tag> tags;

    private double r = 0.0;

    Cloud(ArrayList<Tag> tags)
    {
        this.tags = new ArrayList<Tag>();

        //ArrayList<Integer> weights = new ArrayList<Integer>();

        int count = 0;
        for (Tag t: tags)
        {
            this.tags.add(t.clone());

            if (count == 0)
            {
                min = t.getWeight();
                max = t.getWeight();
            }
            else
            {
                if (t.getWeight() < min)
                    min = t.getWeight();

                if (t.getWeight() > max)
                    max = t.getWeight();
            }

            //weights.add(t.getWeight());
            count++;
        }

        r = (double)(MAX_FONT_SIZE - MIN_FONT_SIZE) / (double)(max - min);
    }

    public JPanel renderJPanel()
    {
        JPanel tagCloudPanel = new JPanel(new FlowLayout(FlowLayout.LEFT));
        tagCloudPanel.setPreferredSize(new java.awt.Dimension(100, 700));

        for (Tag t: this.tags)
        {
          //  double font_size = (((t.getWeight()*MAX_FONT_SIZE) - (min*MAX_FONT_SIZE) + (max*MIN_FONT_SIZE) - (t.getWeight()*MIN_FONT_SIZE))/(max-min));
            double font_size = MIN_FONT_SIZE + ((t.getWeight() - min) * r);

            JLabel temp = new JLabel(" [" + t.getName() + "(" + t.getWeight() + ")] ");
            temp.setFont(new Font("Serif", Font.PLAIN, (int)Math.round(font_size)));
            tagCloudPanel.add(temp);
        }
        
        return tagCloudPanel;
    }

}
