/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;


import java.util.ArrayList;

import com.mxgraph.layout.mxFastOrganicLayout;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource.mxIEventListener;
import com.mxgraph.view.mxGraph;

import com.mxgraph.layout.*;
import com.mxgraph.model.*;
import jview.*;

/**
 *
 * @author Lou
 */
public class DependenciesFromViewGraph extends mxGraph
{
    private mxGraphComponent graphComponent;
     
    DependenciesFromViewGraph(JavaEntity javaEntity)
    {
        graphComponent = new mxGraphComponent(this);
        graphComponent.setConnectable(false);
         
        this.setHtmlLabels( true);
         
        Object parent = this.getDefaultParent();

        ArrayList<Object> objects = new ArrayList<Object>();

        this.setAutoSizeCells(true);
        this.setLabelsClipped( true);
       
        this.getModel().beginUpdate();
        
        try
        {
            //Add main
            Object v = this.insertVertex(parent, null, "<html><div style='padding:5px'>" + javaEntity.getFullName() + "</div>", 300, 200, 120, 40, "strokeColor=#151515;fillColor=#FFFFFF");
            this.updateCellSize(v);
            objects.add(v);
            
            for (Relation relation : javaEntity.getRelationsFrom())
            {
                Object v2 = this.insertVertex(parent, null, "<html><div style='padding:5px'>" + relation.getRelatedEntity() + "</div>", 300, 200, 120, 40, "strokeColor=#151515;fillColor=#FFFFFF");
                this.updateCellSize(v2);
                objects.add(v2);
                
                this.insertEdge(parent, null,  "", v2, v, "strokeColor=#151515");
            }
        }
        finally
        {
            this.getModel().endUpdate();
        }

        // define layout
        mxFastOrganicLayout layout = new com.mxgraph.layout.mxFastOrganicLayout(this);
        layout.setForceConstant( 340); // the higher, the more separated
        layout.setDisableEdgeStyle( false);
    
        // layout using morphing
        this.getModel().beginUpdate();
        
        try
        {
            layout.execute(this.getDefaultParent());
        }
        finally
        {
            mxMorphing morph = new mxMorphing(graphComponent, 20, 1.2, 20);

            morph.addListener(mxEvent.DONE, new mxIEventListener()
            {
                @Override
                public void invoke(Object arg0, mxEventObject arg1)
                {
                    getModel().endUpdate();
                }

            });

            morph.startAnimation();
        }
    }

    @Override
    public boolean isCellSelectable(Object cell)
    {
         if (cell != null)
         {
            if (cell instanceof mxCell)
            {
               mxCell myCell = (mxCell) cell;
               if (myCell.isEdge())
                  return false;
            }
         }
         return super.isCellSelectable(cell);
    }
    
    public mxGraphComponent getGraphComponent()
    {
        return graphComponent;
    }
}
