/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;


import java.awt.BorderLayout;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import jview.JavaEntity;
import jview.Project;

/**
 *
 * @author Lou
 */
public class DependenciesToViewPanel extends JPanel
{
    private JComboBox viewBy;
    private JScrollPane scrollPane;

    DependenciesToViewPanel()
    {
        this.setLayout(new BorderLayout());
        
        viewBy = new JComboBox();
        viewBy.addItem("- Select");
        for(JavaEntity e: Project.getInstance().getEntities())
        {
            int size = e.getUniqueRelationsTo().size();
            if (size > 0)
                viewBy.addItem(e.getFullName() + " (" + size + ")");
        }
        
        viewBy.setBounds(5, 5, 150, 25);

        viewBy.addActionListener (new ActionListener ()
        {
            public void actionPerformed(ActionEvent ae)
            {
                viewByValueChangedActionPerformed(ae);
            }
        });
        
        scrollPane = new JScrollPane();
        add(scrollPane, BorderLayout.CENTER);
        
        add(viewBy, BorderLayout.PAGE_START);
    }
    
    private void viewByValueChangedActionPerformed(ActionEvent ae)
    {
        String selected = viewBy.getSelectedItem().toString();
        
        if (selected.equals("- Select"))
        {
            this.remove(scrollPane);
            scrollPane = new JScrollPane();
            add(scrollPane, BorderLayout.CENTER);
            remove(viewBy);
            add(viewBy, BorderLayout.PAGE_START);
            this.repaint();
            this.revalidate();
            return;
        }
        
        selected = selected.substring(0, selected.indexOf(" "));

        this.remove(scrollPane);
        scrollPane = new DependenciesToViewGraph(Project.getInstance().getClassByFullName(selected)).getGraphComponent();
        add(scrollPane, BorderLayout.CENTER);
        
        remove(viewBy);
        add(viewBy, BorderLayout.PAGE_START);
        this.repaint();
        this.revalidate();
    }
}
