package gui;

import java.awt.BorderLayout;
import java.awt.Font;
import javax.swing.*;
import jview.*;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

/**
 *
 * @author Lou
 */
public class GridViewPanel extends JPanel
{
    GridViewPanel(){}

    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        
        Graphics2D g2d = (Graphics2D)g;
        
        int left = 200;
        int top = 200;
        
        ArrayList<JavaPackage> packages = Project.getInstance().getPackages();
        int size = packages.size();
        
        for (int i = 0; i <= size; i++)
        {
            g2d.drawLine(left, top + i * 20, left + size * 20, top + i * 20);
            
            if (i < size)
                g2d.drawString(packages.get(i).getName(), (left - 5) - (g.getFontMetrics().stringWidth(packages.get(i).getName())) , (top + 15) + i * 20);
        }
        
        for (int j = 0; j <= size; j++)
        {
            g2d.drawLine(left + j * 20, top, left + j * 20, top + size * 20);
            
            if (j < size)
            {
                g2d.rotate(Math.toRadians(-90), left + j * 20, top);
                g2d.drawString(packages.get(j).getName(), left + j * 20, top);
                g2d.rotate(Math.toRadians(-90), left + j * 20, top);
            }
        }
    }
}
