/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;

import javax.swing.*;
import java.awt.event.*;
import java.awt.Graphics.*;
import jview.Project;

/**
 *
 * @author Lou
 */
public class MainFrame extends JFrame
{
    private JMenuBar menuBar;
    private JScrollPane mainScrollPane;
    private JMenu fileMenu;
    private JMenu viewMenu;
    private JMenuItem openFile;
    private JMenuItem closeFile;
    private JMenuItem exitProject;
    private JMenu simpleView;
    private JMenu dependenciesMenu;
    private JMenu packageCouplingsMenu;
    private JMenuItem classesSimpleView;
    private JMenuItem interfacesSimpleView;
    private JMenuItem tagCloudView;
    private JMenuItem classDiagramView;
    private JMenuItem dependenciesToView;
    private JMenuItem dependenciesFromView;
    private JMenuItem gridView;
    private JMenuItem pieChartView;
    private JMenuItem packagesEfferentCouplingsView;
    private JMenuItem packagesAfferentCouplingsView;

    public MainFrame()
    {
        setBounds(java.awt.Toolkit.getDefaultToolkit().getScreenSize().width/2 - 500, java.awt.Toolkit.getDefaultToolkit().getScreenSize().height/2 - 400, 1000, 800);
        setTitle("jView");
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        
        // Add the menubar to the frame
        menuBar = new JMenuBar();
        setJMenuBar(menuBar);

        mainScrollPane = new JScrollPane();
        //this.showDefaultPanel();
        this.getContentPane().add(mainScrollPane);
        

        fileMenu = new JMenu("File");
        viewMenu = new JMenu("View");
        viewMenu.setEnabled(false);
        menuBar.add(fileMenu);
        menuBar.add(viewMenu);

        //fileMenu items
        openFile = new JMenuItem("Open Project");
        closeFile = new JMenuItem("Close Project");
        closeFile.setEnabled(false);
        exitProject = new JMenuItem("Exit");

        fileMenu.add(openFile);
        fileMenu.add(closeFile);
        fileMenu.add(exitProject);

        openFile.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                openFileActionPerformed(ae);
            }
        });

        closeFile.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                closeFileActionPerformed(ae);
            }
        });

        exitProject.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                System.exit(0);
            }
        });

        //viewMenu items
        simpleView = new JMenu("Simple");
        viewMenu.add(simpleView);

        classesSimpleView = new JMenuItem("Classes");
        simpleView.add(classesSimpleView);

        classesSimpleView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                simpleViewClassesMenuItemActionPerformed(ae);
            }
        });

        interfacesSimpleView = new JMenuItem("Interfaces");
        simpleView.add(interfacesSimpleView);

        interfacesSimpleView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                simpleViewInterfacesMenuItemActionPerformed(ae);
            }
        });
        
        tagCloudView = new JMenuItem("Entity Cloud");
        viewMenu.add(tagCloudView);

        tagCloudView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                tagCloudViewMenuItemActionPerformed(ae);
            }
        });

        classDiagramView = new JMenuItem("Class Diagram");
        viewMenu.add(classDiagramView);

        classDiagramView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                classDiagramViewMenuItemActionPerformed(ae);
            }
        });
        
        dependenciesMenu = new JMenu("Couplings");
        viewMenu.add(dependenciesMenu);
        
        dependenciesToView = new JMenuItem("Efferent");
        dependenciesMenu.add(dependenciesToView);

        dependenciesToView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                dependenciesToViewMenuItemActionPerformed(ae);
            }
        });
        
        dependenciesFromView = new JMenuItem("Afferent");
        dependenciesMenu.add(dependenciesFromView);

        dependenciesFromView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                dependenciesFromViewMenuItemActionPerformed(ae);
            }
        });

        gridView = new JMenuItem("Grid");
        //viewMenu.add(gridView);

        gridView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                gridViewMenuItemActionPerformed(ae);
            }
        });
        
        pieChartView = new JMenuItem("Pie Chart");
        viewMenu.add(pieChartView);

        pieChartView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                pieChartViewMenuItemActionPerformed(ae);
            }
        });
        
        packageCouplingsMenu = new JMenu("Package Couplings");
        viewMenu.add(packageCouplingsMenu);

        packagesEfferentCouplingsView = new JMenuItem("Efferent");
        packageCouplingsMenu.add(packagesEfferentCouplingsView);

        packagesEfferentCouplingsView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                packagesEfferentCouplingsViewMenuItemActionPerformed(ae);
            }
        });
        
        packagesAfferentCouplingsView = new JMenuItem("Afferent");
        packageCouplingsMenu.add(packagesAfferentCouplingsView);

        packagesAfferentCouplingsView.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                packagesAfferentCouplingsViewMenuItemActionPerformed(ae);
            }
        });
        
        setVisible(true);
    }

    private void simpleViewClassesMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new SimpleViewClassesPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth() - 34, this.getHeight() - 64));
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }

    private void simpleViewInterfacesMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new SimpleViewInterfacesPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth() - 34, this.getHeight() - 64));
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }

    private void tagCloudViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new TagCloudViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth() - 34, this.getHeight() - 64));
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }

    private void dependenciesToViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new DependenciesToViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void dependenciesFromViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new DependenciesFromViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void classDiagramViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        mainScrollPane = new ClassDiagramGraph().getGraphComponent();
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void pieChartViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        //JPanel panel = new DependenciesViewPanel();
        JPanel panel = new PieChartViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }

    private void gridViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        //JPanel panel = new DependenciesViewPanel();
        JPanel panel = new GridViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void packagesEfferentCouplingsViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new PackagesEfferentCouplingsViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void packagesAfferentCouplingsViewMenuItemActionPerformed(ActionEvent ae)
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new PackagesAfferentCouplingsViewPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }

    private void showDefaultPanel()
    {
        this.getContentPane().remove(mainScrollPane);
        JPanel panel = new DefaultPanel();
        panel.setPreferredSize(new java.awt.Dimension(this.getWidth(), 920));
        panel.setBounds(0, 0, this.getWidth(), 920);
        mainScrollPane = new JScrollPane(panel);
        this.getContentPane().add(mainScrollPane);
        this.getLayeredPane().revalidate();
    }
    
    private void openFileActionPerformed(ActionEvent ae)
    {
        JFileChooser fc = new JFileChooser();
        fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        int returnVal = fc.showOpenDialog(fc);
        if(returnVal == JFileChooser.APPROVE_OPTION)
            this.openProject(fc.getSelectedFile().getPath());
    }
    
    public void openProject(String path)
    {
        this.closeProject();
        
        try
        {
             Project.getInstance().load(path);
             this.closeFile.setEnabled(true);
             this.viewMenu.setEnabled(true);
        }
        catch (Exception e)
        {
            JOptionPane.showMessageDialog(this, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE); 
        } 
    }
    
    private void closeFileActionPerformed(ActionEvent ae)
    {
        this.closeProject();
    }
    
    public void closeProject()
    {
        this.getContentPane().remove(mainScrollPane);
        mainScrollPane = new JScrollPane();
        this.getContentPane().add(mainScrollPane);
        this.closeFile.setEnabled(false);
        this.viewMenu.setEnabled(false);
        
        this.repaint();
        //this.revalidate();

        Project.getInstance().reset();
    }
}
