/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gui;


import java.util.ArrayList;

import com.mxgraph.layout.mxFastOrganicLayout;
import com.mxgraph.swing.mxGraphComponent;
import com.mxgraph.swing.util.mxMorphing;
import com.mxgraph.util.mxEvent;
import com.mxgraph.util.mxEventObject;
import com.mxgraph.util.mxEventSource.mxIEventListener;
import com.mxgraph.view.mxGraph;

import com.mxgraph.layout.*;
import com.mxgraph.model.*;
import java.util.HashMap;
import java.util.Map;
import jview.*;

/**
 *
 * @author Lou
 */
public class PackagesAfferentCouplingsViewGraph extends mxGraph
{
    private mxGraphComponent graphComponent;
     
    PackagesAfferentCouplingsViewGraph(ArrayList<JavaPackage> javaPackages)
    {
        graphComponent = new mxGraphComponent(this);
        graphComponent.setConnectable(false);
         
        this.setHtmlLabels(true);
         
        Object parent = this.getDefaultParent();

        HashMap<String, Object> objects = new HashMap<String, Object>();
        this.setAutoSizeCells(true);
        this.setLabelsClipped( true);
       
        this.getModel().beginUpdate();
        
        try
        {
            for (JavaPackage p: javaPackages)
            {
                Object v = this.insertVertex(parent, null, "<html><div style='padding:5px'>" + p.getName() + "</div>", 300, 200, 120, 40, "strokeColor=#151515;fillColor=#FFFFFF");
                this.updateCellSize(v);
                objects.put(p.getName(), v);
            }
            
            for (JavaPackage p: javaPackages)
            {
                System.out.println("----------------");
                System.out.println(p.getName());
                for (Map.Entry<String, Integer> entry : p.getAfferentCoupling().entrySet())
                {
                    Object from = objects.get(p.getName());
                    Object target = objects.get(entry.getKey());

                    this.insertEdge(parent, null, entry.getValue(), from, target, "strokeColor=#151515;fontSize=24");
                }
            }

            for (Map.Entry<String, Object> v : objects.entrySet())
            {
                if (this.getModel().getEdgeCount(v.getValue()) == 0)
                    this.getModel().remove(v.getValue());
            }
        }
        finally
        {
            this.getModel().endUpdate();
        }

        // define layout
        mxFastOrganicLayout layout = new com.mxgraph.layout.mxFastOrganicLayout(this);
        layout.setForceConstant( 340); // the higher, the more separated
        layout.setDisableEdgeStyle( false);
    
        // layout using morphing
        this.getModel().beginUpdate();
        
        try
        {
            layout.execute(this.getDefaultParent());
        }
        finally
        {
            mxMorphing morph = new mxMorphing(graphComponent, 20, 1.2, 20);

            morph.addListener(mxEvent.DONE, new mxIEventListener()
            {
                @Override
                public void invoke(Object arg0, mxEventObject arg1)
                {
                    getModel().endUpdate();
                }

            });

            morph.startAnimation();
        }
    }

    @Override
    public boolean isCellSelectable(Object cell)
    {
         if (cell != null)
         {
            if (cell instanceof mxCell)
            {
               mxCell myCell = (mxCell) cell;
               if (myCell.isEdge())
                  return false;
            }
         }
         return super.isCellSelectable(cell);
    }
    
    public mxGraphComponent getGraphComponent()
    {
        return graphComponent;
    }
}
