package gui;

import javax.swing.*;
import java.util.ArrayList;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import jview.JavaEntity;
import jview.Project;

/**
 *
 * @author Lou
 */
public class TagCloudViewPanel extends JPanel
{
    private JComboBox viewBy;
    private JPanel cloudPanel;
    private JScrollPane cloudPanelPane;

    TagCloudViewPanel()
    {
        this.setLayout(null);
        
        viewBy = new JComboBox(new String[]{"- Select", "LoC", "Properties", "Methods", "Ce", "Ca"});
        viewBy.setBounds(5, 5, 150, 25);

        viewBy.addActionListener (new ActionListener ()
        {
            public void actionPerformed(ActionEvent ae)
            {
                viewByValueChangedActionPerformed(ae);
            }
        });

        add(viewBy);

        cloudPanelPane = new JScrollPane();
        this.add(cloudPanelPane);
    }

    private void loadPanel(ArrayList<Tag> tags)
    {
        this.remove(cloudPanelPane);
      ;//  p.setPreferredSize(this.getPreferredSize());
        cloudPanel = new Cloud(tags).renderJPanel();
        cloudPanel.setPreferredSize(new java.awt.Dimension(this.getWidth() - 40, 5000));
            
        cloudPanelPane = new JScrollPane(cloudPanel);
        cloudPanelPane.setAutoscrolls(true);
        cloudPanelPane.setBounds(5, 40, this.getWidth() - 10, this.getHeight() - 50);
        this.add(cloudPanelPane);
        this.repaint();
        this.revalidate();
        System.out.println("ASD");
    }

    private void viewByValueChangedActionPerformed(ActionEvent ae)
    {
        ArrayList<Tag> tags = new ArrayList<Tag>();
        if(viewBy.getSelectedItem().toString().equals("Properties"))
        {
            for (JavaEntity e: Project.getInstance().getEntities())
                tags.add(new Tag(e.getName(), e.getProperties().size()));
        }
        else if(viewBy.getSelectedItem().toString().equals("Methods"))
        {
            for (JavaEntity e: Project.getInstance().getEntities())
                tags.add(new Tag(e.getName(), e.getMethods().size()));
        }
        else if(viewBy.getSelectedItem().toString().equals("LoC"))
        {
            for (JavaEntity e: Project.getInstance().getEntities())
                tags.add(new Tag(e.getName(), e.getLoc()));
        }
        else if(viewBy.getSelectedItem().toString().equals("Ce"))
        {
            for (JavaEntity e: Project.getInstance().getEntities())
                tags.add(new Tag(e.getName(), e.getRelationsTo().size()));
        }
        else if(viewBy.getSelectedItem().toString().equals("Ca"))
        {
            for (JavaEntity e: Project.getInstance().getEntities())
                tags.add(new Tag(e.getName(), e.getRelationsFrom().size()));
        }
        else
        {
            this.remove(cloudPanelPane);
            cloudPanelPane = new JScrollPane();
            this.add(cloudPanelPane);
            this.repaint();
            this.revalidate();
            return;
        }

        this.loadPanel(tags);
    }
}
