package jview;

/**
 *
 * @author Lou
 */
public class ArgumentParser
{
    public static JavaArgument parse(String blockCode)
    {
        JavaArgument argument = new JavaArgument();
        
        blockCode = blockCode.trim();

        boolean isFinal = false;
        blockCode = " ".concat(blockCode);
        if (blockCode.contains(" final "))
        {
            isFinal = true;
            blockCode = blockCode.replace(" final ", " ");
        }

        String name = "";
        boolean isArray = false;
        String type = "";

        int blockCodeLength = blockCode.length();
        int stopped = blockCodeLength - 1;

        for (int i = blockCodeLength - 1; i >= 0; i--)
        {
            char x = blockCode.charAt(i);

            if (!name.equals("") && (x == ' ' || x == ']' || x == '>'))
            {
                stopped = i;
                break;
            }

            name = x + name;
        }

        if (name.contains("["))
        {
            isArray = true;
            name = name.replace("[", "");
            name = name.replace("]", "");
        }

        type = blockCode.substring(0, stopped + 1).trim();

        if (type.endsWith("]"))
            isArray = true;

        type = type.replace(" ", "").replace("[", "").replace("]", "").trim();

        argument.setName(name);
        argument.setIsArray(isArray);
        argument.setIsFinal(isFinal);
        argument.setType(type);

        return argument;
    }
}
