/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jview;

import java.util.ArrayList;

/**
 *
 * @author Lou
 */
public class ClassParser
{
    public static JavaClass parse(String packageName, ArrayList<String> imports, String code, String prefix)
    {
        //System.out.println("Examining class...");

        JavaClass javaClass = new JavaClass();
        javaClass.setPackageName(packageName);
        javaClass.setImports(imports);

        String head = code.substring(0, code.indexOf("{"));
        String body = code.substring(code.indexOf("{"));
        body = body.substring(body.indexOf("{") + 1, body.lastIndexOf("}")).trim();

        head = head.replaceAll("<[^>]+>", "").replace(",", " ");

        if (head.contains("extends"))
            javaClass.setParentClass(ParserUtil.getNextTargetToken(head, "extends"));

        if (head.contains("implements")) //to implements mpainei panta meta to extends
        {
            String temp = "implements";
            do
            {
                javaClass.getImplements().add(ParserUtil.getNextTargetToken(head, temp));
                temp = ParserUtil.getNextTargetToken(head, temp);
            }
            while (!ParserUtil.isLastToken(head, temp));
        }

        javaClass.setCode(body);
        javaClass.setLoc(ParserUtil.countLoc(code));

        javaClass.setName(ParserUtil.getNextTargetToken(head.trim(), "class"));
        javaClass.setFullName(packageName.concat(".").concat(prefix).concat(javaClass.getName()));
        ArrayList<String> codeBlocks = ParserUtil.splitBlocks(body);

        int i=0;
        for(String codeBlock: codeBlocks)
        {
            i++;
            int flag = 0;
            int method_possibility = 0; //method_possibility = 3 means that codeBlock is method otherwise it's property
            int codeBlock_length = codeBlock.length();

            loop: for(int x = 0; x < codeBlock_length; x++)
            {

                switch(codeBlock.charAt(x))
                {
                    case '=' :
                        if (flag == 0)
                        {
                            method_possibility = 0;
                            JavaProperty p = PropertyParser.parse(codeBlock);
                            javaClass.addProperty(p);
                            break loop;
                        }

                        break;

                    case '(' :
                        if(flag == 0)
                            method_possibility++;

                        break;

                    case ')' :
                        if(flag == 0)
                            method_possibility++;

                        break;

                    case '{' :
                        if(flag == 0)
                            method_possibility++;

                        flag++;
                        break;

                    case '}' :
                        flag--;
                        if(flag == 0)
                        {
                            if(method_possibility == 3)
                            {
                                JavaMethod m = MethodParser.parse(codeBlock);
                                if (m.getName().equals(javaClass.getName()))
                                    m.setIsConstructor(true);
                                javaClass.addMethod(m);
                                break loop;
                            }
                            else
                            if (method_possibility == 1)
                            {
                                String temp = codeBlock.substring(0, codeBlock.indexOf("{"));

                                if (temp.indexOf("class") != -1)
                                    javaClass.addInternalEntity(ClassParser.parse(packageName, imports, codeBlock.trim(), prefix + javaClass.getName().concat("$")));
                                else
                                if (temp.indexOf("interface") != -1)
                                    javaClass.addInternalEntity(InterfaceParser.parse(packageName, imports, codeBlock.trim(), prefix + javaClass.getName().concat("$")));
                            }
                        }
                        break;

                    case ';' :

                        if(flag == 0)
                        {
                            if (x == (codeBlock_length - 1) && method_possibility == 0) //An to erotimnatiko einai sto telos tou block kai den exei parentheseis
                            {
                                JavaProperty p  = PropertyParser.parse(codeBlock);
                                if (p.isMultiple())
                                {
                                    for (JavaProperty p2: p.splitProperties())
                                        javaClass.addProperty(p2);
                                }
                                else
                                    javaClass.addProperty(p);
                            }
                            else //Einai abstract methodos, esoteriki class i interface
                            {
                                if (!codeBlock.contains("{")) //Tote einai abstract methodos
                                {
                                    JavaMethod m = MethodParser.parse(codeBlock);
                                    javaClass.addMethod(m);
                                }
                            }

                        }
                        break;
                }
            }
        }

        return javaClass;
    }
}