/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jview;

import java.util.ArrayList;

/**
 *
 * @author Lou
 */
public class InterfaceParser
{
    public static JavaInterface parse(String packageName, ArrayList<String> imports, String code, String prefix)
    {
        JavaInterface javaInterface = new JavaInterface();
        javaInterface.setPackageName(packageName);
        javaInterface.setImports(imports);

        String head = code.substring(0, code.indexOf("{"));
        String body = code.substring(code.indexOf("{"));

        javaInterface.setName(ParserUtil.getNextTargetToken(head.trim(), "interface"));
        javaInterface.setFullName(packageName.concat(".").concat(prefix).concat(javaInterface.getName()));

        if (head.contains(" extends ")) //to implements mpainei panta meta to extends
        {
            for (String parentInterface: head.substring(head.indexOf(" extends ") + 9).split(","))
                javaInterface.addParentInterface(parentInterface.trim());
        }

        javaInterface.setCode(body);
        javaInterface.setLoc(ParserUtil.countLoc(code));

        ArrayList<String> codeBlocks = ParserUtil.splitBlocks(body.substring(body.indexOf("{") + 1, body.lastIndexOf("}")));

         int i=0;
        for(String codeBlock: codeBlocks)
        {
            i++;
            int flag = 0;
            int method_possibility = 0; //method_possibility = 3 means that codeBlock is method otherwise it's property
            int codeBlock_length = codeBlock.length();

            loop: for(int x = 0; x < codeBlock_length; x++)
            {

                switch(codeBlock.charAt(x))
                {
                    case '=' :
                        if (flag == 0)
                        {
                            method_possibility = 0;
                            JavaProperty p = PropertyParser.parse(codeBlock);
                            javaInterface.addProperty(p);
                            p.setIsFinal(true); //Override
                            p.setIsStatic(true); //Override
                            break loop;
                        }

                        break;

                    case '(' :
                        if(flag == 0)
                            method_possibility++;

                        break;

                    case ')' :
                        if(flag == 0)
                            method_possibility++;

                        break;

                    case '{' :
                        if(flag == 0)
                            method_possibility++;

                        flag++;
                        break;

                    case '}' :
                        flag--;
                        if(flag == 0)
                        {
                            if(method_possibility == 3)
                            {
                                JavaMethod m = MethodParser.parse(codeBlock);
                                javaInterface.addMethod(m);
                                break loop;
                            }
                            else
                            if (method_possibility == 1)
                            {
                                String temp = codeBlock.substring(0, codeBlock.indexOf("{"));

                                if (temp.indexOf("class") != -1)
                                    javaInterface.addInternalEntity(ClassParser.parse(packageName, imports, codeBlock.trim(), prefix + javaInterface.getName().concat("$")));
                                else
                                if (temp.indexOf("interface") != -1)
                                    javaInterface.addInternalEntity(InterfaceParser.parse(packageName, imports, codeBlock.trim(), prefix + javaInterface.getName().concat("$")));
                            }
                        }
                        break;

                    case ';' :

                        if(flag == 0)
                        {
                            if (x == (codeBlock_length - 1) && method_possibility == 0) //An to erotimnatiko einai sto telos tou block kai den exei parentheseis
                            {
                                JavaProperty p  = PropertyParser.parse(codeBlock);
                                p.setIsFinal(true); //Override
                                p.setIsStatic(true); //Override
                                if (p.isMultiple())
                                {
                                    for (JavaProperty p2: p.splitProperties())
                                        javaInterface.addProperty(p2);
                                }
                                else
                                    javaInterface.addProperty(p);
                            }
                            else //Einai abstract methodos, esoteriki class i interface
                            {
                                if (!codeBlock.contains("{")) //Tote einai abstract methodos
                                {
                                    JavaMethod m = MethodParser.parse(codeBlock);
                                    javaInterface.addMethod(m);
                                }
                            }

                        }
                        break;
                }
            }
        }

        return javaInterface;
    }
}
