/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jview;

import java.util.ArrayList;

/**
 * - mporei na exei parent polla interfaces eno i classi mono mia alli classi
 * - oi methodoi einai abstract kai public by default k ara den einai pote static i final
 * - ta properties einai static final
 *
 * @author Administrator
 */
public class JavaInterface extends JavaEntity
{
    private ArrayList<String> parentInterfaces;

    JavaInterface()
    {
        parentInterfaces = new ArrayList<String>();
    }

    public void addParentInterface(String parentInterface)
    {
        this.parentInterfaces.add(parentInterface);
    }

    public ArrayList<String> getParentInterfaces()
    {
        return parentInterfaces;
    }

    public String parentInterfacesAsString()
    {
        String name = "";
        for(String s: parentInterfaces)
            name = name.concat("[").concat(s).concat("]");

        return name;
    }

    @Override
    public void generateMoreRelations(ArrayList<JavaPackage> javaPackages)
    {
        //Extract extends
        if(parentInterfaces.size() > 0) //if there are parent intefaces
        {
            for (String i : parentInterfaces)
            {
                loop : for (JavaPackage p : javaPackages)
                {
                    if(p.hasEntityFullName(i))
                    {
                        this.addRelationTo(new Relation(i, "Inheritance"));
                        break loop;
                    }
                }
            }
        }
    }

    public void fixMore(ArrayList<JavaPackage> javaPackages)
    {
        //Fix extends
        for (int i = 0; i < this.parentInterfaces.size(); i++)
        {
            if (parentInterfaces.get(i).contains(".")) //Implement already in fulltype
            {
                continue;
            }

            parentInterfaces.set(i, this.findFullType(parentInterfaces.get(i), javaPackages, false));
        }
    }
}
