/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jview;


import java.util.ArrayList;
import java.util.HashMap;
/**
 *
 * @author Lou
 */
public class JavaPackage
{
    String name;
    ArrayList<JavaEntity> entities;

    public JavaPackage()
    {
        entities = new ArrayList<JavaEntity>();
    }

    public JavaPackage(String name)
    {
        this.name = name;
        entities = new ArrayList<JavaEntity>();
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public String getName()
    {
        return name;
    }

    public void addEntity(JavaEntity e)
    {
        this.entities.add(e);
    }

    public ArrayList<JavaEntity> getEntities()
    {
        return this.entities;
    }

    public boolean hasEntityName(String entityName)
    {
        for (JavaEntity e: entities)
            if(e.getName().equals(entityName))
                return true;

        return false;
    }

    public boolean hasEntityFullName(String entityFullName)
    {
        for (JavaEntity e: entities)
            if(e.getFullName().equals(entityFullName))
                return true;

        return false;
    }

    public void print()
    {
        System.out.println("Package: " + name + " Entities: " + entities.size());

        for (JavaEntity entity: this.entities)
            entity.print(0);
    }

    public HashMap<String, Integer> getEfferentCoupling()
    {
        HashMap<String, Integer> coupling = new HashMap<String, Integer>();
        
        for (JavaEntity entity: this.entities)
        {
            for (Relation r: entity.getRelationsTo())
            {
                String p = r.getRelatedEntity().substring(0, r.getRelatedEntity().lastIndexOf("."));
                if (p.equals(this.name))
                    continue;
                
                Integer value = new Integer(1);
                if (coupling.containsKey(p))
                    value = coupling.get(p) + 1;
                    
                coupling.put(p, value);
            }
        }
        
        return coupling;
    }

    public HashMap<String, Integer> getAfferentCoupling()
    {
        HashMap<String, Integer> coupling = new HashMap<String, Integer>();

        for (JavaEntity entity: this.entities)
        {
            for (Relation r: entity.getRelationsFrom())
            {
                String p = r.getRelatedEntity().substring(0, r.getRelatedEntity().lastIndexOf("."));
                if (p.equals(this.name))
                    continue;

                Integer value = new Integer(1);
                if (coupling.containsKey(p))
                    value = coupling.get(p) + 1;

                coupling.put(p, value);
            }
        }

        return coupling;
    }
}