/*
 * 
 * 
 */
package jview;

import java.util.ArrayList;

/**
 *
 * @author Lou
 */
public class JavaProperty
{
    private String name;
    private String type;
    private String access;
    private boolean isArray;
    private boolean isStatic;
    private boolean isFinal;

    JavaProperty()
    {
        
    }

    JavaProperty(String access, String type, String nam, boolean isArray)
    {
        this.access = access;
        this.name = name;
        this.type = type;
        this.isArray = isArray;
    }

    public void setAccess(String access)
    {
        this.access = access;
    }

    public String getAccess()
    {
        return access;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public String getName()
    {
        return name;
    }

    public void setType(String type)
    {
        this.type = type;
    }

    public String getType()
    {
        return type;
    }

    public void setIsArray(boolean isArray)
    {
        this.isArray = isArray;
    }

    public boolean getIsArray()
    {
        return isArray;
    }

    public void setIsStatic(boolean isStatic)
    {
        this.isStatic = isStatic;
    }

    public boolean getIsStatic()
    {
        return isStatic;
    }

    public void setIsFinal(boolean isFinal)
    {
        this.isFinal = isFinal;
    }

    public boolean getIsFinal()
    {
        return isFinal;
    }

    public ArrayList<String> extractRelations(ArrayList<JavaPackage> packages)
    {
        ArrayList<String> s = new ArrayList<String>();

        for(JavaPackage p : packages)
        {
            if (p.hasEntityFullName(this.formattedType()))
            {
                s.add(this.getType());
                break;
            }
        }

        return s;
    }

    public String formattedType()
    {
        try
        {
        if(type.contains("<"))
            type = type.substring(type.indexOf("<") + 1, type.lastIndexOf(">"));
        }
        catch(Exception e)
        {
            this.print();
        }


        return type;
    }

    public void print()
    {
        System.out.print("Name : " + name + ", Type : " + type + ", Access : " + access + " --->");
        
        if(isStatic)
            System.out.print("<static>");

        if(isFinal)
            System.out.print("<final>");

        if(isArray)
            System.out.print("<array>");

        
        System.out.println(" ");
    }
    
    public boolean isMultiple()
    {
        return this.name.contains(",");
    }
    
    public ArrayList<JavaProperty> splitProperties()
    {
        ArrayList<JavaProperty> list = new ArrayList<JavaProperty>();
        for(String n: this.name.split(","))
        {
            JavaProperty p = new JavaProperty();
            p.setAccess(this.access);
            p.setType(this.type);
            p.setName(n.trim());
            p.setIsFinal(this.isFinal);
            p.setIsStatic(this.isStatic);
            list.add(p);
        }
        
        return list;
    }

}
