/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jview;

import java.util.ArrayList;
import java.util.Arrays;

/**
 *
 * @author Lou
 */
public class MethodParser
{
   public static JavaMethod parse(String blockCode)
    {
        JavaMethod method = new JavaMethod();
        String head = "";

        if (!blockCode.contains("{")) //if method is abstract
        {
            head = blockCode.substring(0, blockCode.indexOf(";")).trim();
            method.setCode("");
            method.setIsAbstract(true);
        }
        else //if method is not abstract
        {
            head = blockCode.substring(0, blockCode.indexOf("{")).trim();
            method.setCode(blockCode.substring(blockCode.indexOf("{")).trim());
            method.setIsAbstract(false);
        }

        String declaration = head.substring(0, head.indexOf("(")).trim();
        String arguments = head.substring(head.indexOf("(") + 1, head.indexOf(")")).trim();


        //Method declaration could be handled like a property
        JavaProperty temp = PropertyParser.parse(declaration);

        method.setName(temp.getName());
        method.setReturnType(temp.getType());
        method.setReturnTypeIsArray(temp.getIsArray());
        method.setIsStatic(temp.getIsStatic());
        method.setIsFinal(temp.getIsFinal());

        //Find method's arguments
        ArrayList<String> args = ParserUtil.splitArguments(arguments);
        for(String a : args)
            method.addArgument(ArgumentParser.parse(a));
       
        return method;
    }


}