/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package jview;

import com.sun.jmx.snmp.Timestamp;
import java.util.ArrayList;
import java.io.*;

/**
 *
 * @author Administrator
 */
public class Project 
{
    private static Project instance = null;
    
    private ArrayList<JavaFile> javaFiles;
    private ArrayList<JavaEntity> entities;
    private ArrayList<JavaClass> classes;
    private ArrayList<JavaInterface> interfaces;
    private ArrayList<JavaPackage> packages;
    
    /**
     * 
     */
    private Project()
    {
        this.javaFiles = new ArrayList<JavaFile>();
        this.entities = new ArrayList<JavaEntity>();
        this.classes = new ArrayList<JavaClass>();
        this.interfaces = new ArrayList<JavaInterface>();
        this.packages = new ArrayList<JavaPackage>();
    }
    
    public void reset()
    {
        this.javaFiles = new ArrayList<JavaFile>();
        this.entities = new ArrayList<JavaEntity>();
        this.classes = new ArrayList<JavaClass>();
        this.interfaces = new ArrayList<JavaInterface>();
        this.packages = new ArrayList<JavaPackage>();
    }
    
    /**
     *  
     * @return 
     */
    public static Project getInstance()
    {
        if (instance == null)
            instance = new Project();
        
        return instance;
    }
    
    public void load(String path) throws Exception
    {
        //First force project to reset
        this.reset();
        
        //Read files from source
       for (String file : Filesystem.getSourceFiles(path))
            this.javaFiles.add(new JavaFile(file, Filesystem.getFileContents(file)));

       //If no files were found throw exception
       if (this.javaFiles.isEmpty())
            throw new Exception("No java files found in " + path);

       //this.javaFiles.add(new JavaFile("d:/jview/src/jview/ParserUtil.java", Filesystem.getFileContents("d:/jview/src/jview/ParserUtil.java")));
  //      this.javaFiles.add(new JavaFile("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/test/java/org/archive/crawler/util/FPUriUniqFilterTest.java", Filesystem.getFileContents("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/test/java/org/archive/crawler/util/FPUriUniqFilterTest.java")));
  //    this.javaFiles.add(new JavaFile("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/test/java/org/archive/crawler/util/TopNSetTest.java", Filesystem.getFileContents("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/test/java/org/archive/crawler/util/TopNSetTest.java")));

        //this.javaFiles.add(new JavaFile("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/main/java/org/archive/crawler/restlet/JobRelatedResource.java", Filesystem.getFileContents("C:/Users/Lou/Desktop/heritrix-3.1.0-src/heritrix-3.1.0/engine/src/main/java/org/archive/crawler/restlet/JobRelatedResource.java")));

        //for (JavaFile f : this.javaFiles)

            //System.out.println(f.getPath());
            //f.print();

        //Read the JavaFiles and create the JavaClasses
        Parser parser = new Parser();

        java.util.Date date= new java.util.Date();
        long beginTime = new Timestamp(date.getTime()).getDateTime();
	 System.out.println(new Timestamp(date.getTime()));
        for (JavaFile f : this.javaFiles)
        {
            //System.err.println(f.getPath());
            parser.parseCode(f.getContents());
        }

        parser.fix();
        parser.generateRelationsTo();
        
        parser.generateRelationsFrom();


        long endTime = new Timestamp(date.getTime()).getDateTime();
        long duration = endTime - beginTime;
        System.out.println(new Timestamp(date.getTime()));
        System.out.println(duration);

        this.packages.addAll(parser.getPackages());
        this.entities.addAll(parser.getEntities());
        for (JavaEntity entity: this.entities)
        {
            if (entity instanceof JavaClass)
                this.classes.add((JavaClass)entity);
            else
                this.interfaces.add((JavaInterface)entity);
        }
    }

    public ArrayList<JavaEntity> getEntities()
    {
        return this.entities;
    }
    
    public ArrayList<JavaInterface> getInterfaces()
    {
        return this.interfaces;
    }

    public ArrayList<JavaClass> getClasses()
    {
        return this.classes;
    }
    
    public ArrayList<JavaPackage> getPackages()
    {
        return this.packages;
    }

    public String getClassFullNamesAsString()
    {
        String classFullNames = "";

        for (JavaClass jc : this.getClasses())
        {
            classFullNames = classFullNames.concat(jc.getName().concat(";"));
        }

        return classFullNames;
    }
    
    public JavaEntity getClassByFullName(String fullName)
    {
        for (JavaEntity e : this.getEntities())
            if (e.getFullName().equals(fullName))
                return e;
        
        return null;
    }
    
    public ArrayList<JavaEntity> getEntitiesThatHaveRelationTo(JavaEntity e)
    {
        ArrayList<JavaEntity> related = new ArrayList<JavaEntity>();
        
        for (JavaEntity r: this.entities)
        {
            if (r.hasRelationTo(e))
                related.add(r);
        }
            
        return related;
    }
    
    public JavaPackage getPackageByName(String name)
    {
        for (JavaPackage p: this.packages)
        {
            if (p.getName().equals(name))
                return p;
        }
        
        return null;
    }
}