/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jview;

/**
 *
 * @author Lou
 */
public class PropertyParser
{
    public static JavaProperty parse(String blockCode)
    {
        JavaProperty property = new JavaProperty();

        if(blockCode.contains("="))
            blockCode = blockCode.substring(0, blockCode.indexOf("=")).trim();
        else
            blockCode = blockCode.replace(";", "");

        blockCode = " ".concat(blockCode);

        if(blockCode.contains(" public "))
        {
            property.setAccess("public");
            blockCode = blockCode.replace(" public ", " ");
        }
        else if(blockCode.contains(" private "))
        {
            property.setAccess("private");
            blockCode = blockCode.replace(" private ", " ");
        }
        else if(blockCode.contains(" protected "))
        {
            property.setAccess("protected");
            blockCode = blockCode.replace(" protected ", " ");
        }
        else
            property.setAccess("public");

        if (blockCode.contains(" abstract "))
        {
          //  property.setIsStatic(true);
            blockCode = blockCode.replace(" abstract ", " ");
        }

        if (blockCode.contains(" static "))
        {
            property.setIsStatic(true);
            blockCode = blockCode.replace(" static ", " ");
        }

        if (blockCode.contains(" final "))
        {
            property.setIsFinal(true);
            blockCode = blockCode.replace(" final ", " ");
        }

        blockCode = blockCode.replace(" transient ", " ");
        blockCode = blockCode.replace(" volatile ", " ");
        blockCode = blockCode.replace(" synchronized ", " ");
        
        blockCode = blockCode.trim();
        int blockCodeLength = blockCode.length();

        String name = "";
        boolean isArray = false;
        String type = "";
        int stopped = blockCodeLength - 1;

        for (int i = blockCodeLength - 1; i >= 0; i--)
        {
            char x = blockCode.charAt(i);

            if (!name.equals("") && (x == ' ' || x == ']' || x == '>'))
            {
                stopped = i;
                break;
            }

            name = x + name;
        }

        if (name.contains("["))
        {
            isArray = true;
            name = name.replace("[", "");
            name = name.replace("]", "");
        }

        type = blockCode.substring(0, stopped + 1).trim();

        if (type.endsWith("]"))
            isArray = true;

        type = type.replace(" ", "").replace("[", "").replace("]", "").trim();

        property.setName(name);
        property.setIsArray(isArray);
        property.setType(type);

       /* if(property.getName().contains("[") && property.getName().contains("]"))
        {
            property.setName(property.getName().substring(0, property.getName().indexOf("[")));
            property.setType(property.getType().concat("[]"));
        }*/

        return property;
    }
}
