package jview;

import java.io.*;
import java.util.StringTokenizer;

/**
 *
 * @author Lou
 */
abstract class Reader
{
    
    Reader()
    {
    }

    public String getContent(File file)
    {
        String output = "";

        try
        {
                // Open the file that is the first
                FileInputStream fstream = new FileInputStream(file);
                // Get the object of DataInputStream
                DataInputStream in = new DataInputStream(fstream);
                    BufferedReader br = new BufferedReader(new InputStreamReader(in));
                String strLine;
                //Read File
                while ((strLine = br.readLine()) != null)
                {
                  output = output.concat("\n" + strLine);
                }
                //Close the input stream
                in.close();
        }
        catch (Exception e)
        {//Catch exception if any
          System.err.println("Error: " + e.getMessage());
        }

        //System.out.println(output);
        return output;
    }

    public abstract String getLou(String Louname, int Louage);

    public String getContent(File file, String fileType)
    {
        String output = "";

        if(checkFileType(file, fileType))
        {
            try
            {
                    // Open the file that is the first
                    FileInputStream fstream = new FileInputStream(file);
                    
                    // Get the object of DataInputStream
                    DataInputStream in = new DataInputStream(fstream);
                    BufferedReader br = new BufferedReader(new InputStreamReader(in));
                    String strLine;
                    
                    //Read File
                    while ((strLine = br.readLine()) != null)
                    {
                      output = output.concat("\n" + strLine);
                      //System.out.println(output);
                    }
                    //Close the input stream
                    in.close();
            }
            catch (Exception e)
            {//Catch exception if any
              System.err.println("Error: " + e.getMessage());
            }
        }

        //System.out.println(output);
        return output;
    }
            
    public String readFiles(File dir)
    {
        File[] listOfFiles = dir.listFiles();
        String output = "";
                
        for(int i=0; i<listOfFiles.length; i++)
        {
            if(listOfFiles[i].isDirectory())
                readFiles(listOfFiles[i]);
            else if(listOfFiles[i].isFile())
                output = output.concat(getContent(listOfFiles[i]));
        }
        return output;
    }
    

    public JavaFile[] readFiles(File dir, String fileType)
    {
        JavaFile[] jf = new JavaFile[1000];
        File[] listOfFiles = dir.listFiles();
        int j=0;
        
        for(int i=0; i<listOfFiles.length; i++)
        {
            if(listOfFiles[i].isDirectory())
            {
                for(int x = 0; x < readFiles(listOfFiles[i], fileType).length; x++)
                {
                    jf[j] = readFiles(listOfFiles[i], fileType)[x];
                    j++;
                }
            }
            else if(listOfFiles[i].isFile())
            {
             //   jf[j].setDirectory(dir.getAbsolutePath());
            //    jf[j].setFilename(listOfFiles[i].getName());
            ////    jf[j].setContent(getContent(listOfFiles[i]));
            //    j++;
            }
        }

        return jf;
    }
    
    public boolean checkFileType(File file, String fileType)
    {
        String filename = file.toString();
        String[] temp = filename.split("\\.");
        //System.out.println(temp[1].toUpperCase());
        if(temp[1].equals(fileType))
            return true;
        else
            return false;
    }

    public String[] contentToArray(String text)
    {
        text = ignoreComments(text);
        
        StringTokenizer stArr = new StringTokenizer(text," ");
        while(stArr.hasMoreTokens())
        {
            //stArr.nextToken();
            System.out.println("Token  :" + stArr.nextToken());
        }

        String[] array = text.split(" ");
        return text.split(" ");
        
    }

    public void getClasses(String[] tokens)
    {
        for(int i=0; i<tokens.length; i++)
        {
            if(tokens[i].compareTo("class") == 0)
                System.out.println(tokens[i+1]);
        }
    }


    public String ignoreComments(String text)
    {  
        text = text.replaceAll("((\\/)(\\/)(.(re+))$)", " SINGLELINECOMMENDS ");
        return text;
    }
}
